#ifndef FOLDERVIEW_UTIL_H
#define FOLDERVIEW_UTIL_H

// some useful stuff
#define LowLevelUpdate(wnd) \
SetWindowPos(wnd, 0,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED);

#define SetFont(wnd, fnt) \
SendMessage(wnd, WM_SETFONT, (WPARAM)fnt, MAKELPARAM(TRUE,0))

// memory manager, for freeing up PIDLs
extern LPMALLOC gMalloc; 


// generic popup and error function
inline void error(const char* text,...)
{
	char buffer[512];

	va_list args;

	va_start(args, text);
	vsprintf(buffer, text, args);
	va_end(args);

	MessageBox(NULL, buffer, "FolderView Error", MB_OK);
}

//void PaintDesktopEx(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, int xSrc, int ySrc, BOOL updateCache);

// pidl helpers

BOOL PopupContextMenu(LPITEMIDLIST pidlMain);

UINT GetItemCount (LPITEMIDLIST pidl);
UINT GetItemSize  (LPITEMIDLIST pidl);

LPITEMIDLIST GetNextItem (LPITEMIDLIST pidl);

LPITEMIDLIST DuplicateItem (LPITEMIDLIST pidl);
LPITEMIDLIST MeldItems(LPITEMIDLIST first, LPITEMIDLIST second);

//          for errors    desktop folder           unicode filename   the id list         a real filepath
bool Resolve(HWND owner, LPSHELLFOLDER psfDesktop, OLECHAR* filename, LPITEMIDLIST &pidl, char* path=NULL);

// tokeniser

int ConvertToken(char* token, const char* idlist[], char** args);

#endif