/*============================================================*

	-find.h-	

  FindFile class, for finding files :P


All content  Copyright 2001 Nicholas Cooper.
By Smoogle - Saturday, 23 March 2002 - Initial revision
*============================================================*/
#ifndef FIND_FILE_HEADER_H
#define FIND_FILE_HEADER_H

// TODO:: intergrate into Vdir system

/**-------------------------------------------------------------------------------------------**

	class FindFile

  Finds files matching a regular expression.

By Smoogle - Saturday, 23 March 2002
**-------------------------------------------------------------------------------------------**/
class FindFile
{
public:
	// constructor
	FindFile(const char* str)
	{
		mSearch = FindFirstFile(str, &mFD);

		if(mSearch != INVALID_HANDLE_VALUE)
			ok = true;
		else 
			ok = false;
	}

	// destructor
	~FindFile()
	{
		if(mSearch)
			FindClose(mSearch);
	}

	// get the current file
	operator const char*()
	{
		if(!ok)
			return "";
		return mFD.cFileName;
	}
	// get if we have a file
	operator bool()
	{
		return ok;
	}

	// advance to the enxt file
	bool operator ++ (int)
	{
		return NextFile();
	}

	// find the next file that matches
	bool NextFile()
	{	
		if(ok)
		{
			if(FindNextFile(mSearch, &mFD))
				return true;

			ok = false;
		}
		return false;
	}

protected:
	// win32 find file crap
	WIN32_FIND_DATA mFD;
	HANDLE mSearch;

	// are we ok?
	bool ok;
};

#endif